import multiprocessing as mp
import os
from time import sleep
from random import randrange

print(f'Processors: {mp.cpu_count()}')
print(f'Process name: {mp.current_process().name}')
print(f'PID: {mp.current_process().pid}')
print(f'PPID: {os.getppid()}')

def fcia(x):
    print(f'Process {mp.current_process().name} started.')
    sleep(randrange(2, 10))
    print(f'Process {mp.current_process().name} finished.')
    return x**2

if __name__ == "__main__": #run only in main process
    print(f"Main process: {os.getpid()}")
    ps = [ mp.Process(target=fcia, args=(i,), name=f'PDS{i}') for i in range(5)]
    #start ALL processes
    for p in ps:
        p.start()
    #wait for ALL processes
    for p in ps:
        p.join()
