import multiprocessing as mp
import os
from time import sleep
from random import randrange

print(f'Processors: {mp.cpu_count()}')
print(f'Process name: {mp.current_process().name}')
print(f'PID: {mp.current_process().pid}')
print(f'PPID: {os.getppid()}')

#SENDING DATA FROM MAIN PROCESS TO CHILDREN

#Rad/Queue
q = mp.Queue() #new queue

def fcia(queue):
    print(f'Process {mp.current_process().name} started.')
    sleep(randrange(2, 10))
    x = queue.get() #read data from queue
    print(f'Process {mp.current_process().name} computed {x**2} for {x}')
    print(f'Process {mp.current_process().name} finished.')

if __name__ == "__main__": #run only in main process
    print(f"Main process: {os.getpid()}")
    #NOT GLOBAL VARIABLE FOR ALL PROCESSES!
    ps = [ mp.Process(target=fcia, args=(q,), name=f'PDS{i}') for i in range(5)]
    #start ALL processes
    for p in ps:
        p.start()
    #put elements in queue
    for element in range(2, 7):
        q.put(element)
    #wait for ALL processes
    for p in ps:
        p.join()
