import multiprocessing as mp
import os
from time import sleep
from random import randrange

print(f'Processors: {mp.cpu_count()}')
print(f'Process name: {mp.current_process().name}')
print(f'PID: {mp.current_process().pid}')
print(f'PPID: {os.getppid()}')

#PIPE for communication between 2 processes

def worker(pipe):
    print('Worker started.')
    #read from pipe, calculate, until `END`
    i = 1
    while True:
        command = pipe.recv() #read next line
        if command == 'END':
            return
        print(f'{i:02d}: Received command {command}')
        i += 1

if __name__ == "__main__": #run only in main process
    print(f"Main process: {os.getpid()}")
    #create pipe between 2 processes
    pipe_parent, pipe_child = mp.Pipe() #both ends of pipe
    process = mp.Process(target=worker, args=(pipe_child, ), name=f'Worker')
    process.start()
    sleep(2)
    for i in range(randrange(5, 15)):
        x = randrange(10, 100) #two digit number
        print(f'... put: {x}')
        pipe_parent.send(x)
    pipe_parent.send('END')
    process.join()
